SystemOrganization addCategory: #'Magritte-XMLBinding'!
SystemOrganization addCategory: #'Magritte-XMLBinding-Test'!

MAVisitor subclass: #MXXmlBinding
	instanceVariableNames: 'object target access'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlBinding class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 08:02'!
reader
	self subclassResponsibility! !

!MXXmlBinding class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 08:02'!
writer
	self subclassResponsibility! !

!MXXmlBinding methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:10'!
access
	^ access! !

!MXXmlBinding methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:10'!
access: aNodeAccess
	access := aNodeAccess! !

!MXXmlBinding methodsFor: 'accessing' stamp: 'NorbertHartl 2/21/2010 10:11'!
object
	^ object! !

!MXXmlBinding methodsFor: 'accessing' stamp: 'NorbertHartl 2/21/2010 10:11'!
object: anObject
	object := anObject! !

!MXXmlBinding methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:10'!
target
	^ target! !

!MXXmlBinding methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:09'!
target: aTargetNode
	target := aTargetNode! !

!MXXmlBinding methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 17:45'!
visitMemoDescription: aDescription
	self visitStringDescription: aDescription! !

MXXmlBinding subclass: #MXXmlReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlReader class methodsFor: 'instance creation' stamp: 'pmm 12/6/2006 12:47'!
read: aNode description: aDescription
	^ self new read: aNode description: aDescription! !

!MXXmlReader methodsFor: 'private' stamp: 'pmm 12/5/2006 22:57'!
error: aString
	MAReadError signal: aString! !

!MXXmlReader methodsFor: 'visiting' stamp: 'NorbertHartl 2/21/2010 11:08'!
read: aNode description: aDescription
	self target currentNode: aNode.
	self target description: aDescription.
	^ self target readTarget isNil ifFalse: [
		self visit: aDescription.
		self object ]! !

!MXXmlReader methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:46'!
visitContainer: aDescription
	self object: (MXObject forElementNamed: self target readTarget name asString).
	(aDescription children select: [:each|
		each isReadonly not]) do: [ :each |
		self object
			write: (each readXml: self target readTarget)
			using: each ]! !

!MXXmlReader methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/22/2010 14:17'!
visitNumberDescription: aDescription
	(self access readNode: self target readTarget description: aDescription) ifNotNilDo: [:val|
		self object: val asNumber]! !

!MXXmlReader methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:43'!
visitStringDescription: aDescription
	self object: (self access readNode: self target readTarget description: aDescription)! !

!MXXmlReader methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 14:57'!
visitToManyRelationDescription: aDescription
	self object: (Array streamContents: [ :stream |
		self target readTarget elementsDo: [ :each |
			(each name = aDescription reference xmlElementName asSymbol)
				ifTrue:  [ stream nextPut: (aDescription reference
					readXml: (each))]]])
		
	! !

!MXXmlReader methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 21:20'!
visitToOneRelationDescription: aDescription
	(self access class = MXElementAccess) 
		ifTrue: [	
			self object:( aDescription reference 
				readXml: (self access 
					readNode: self target readTarget 
					description: aDescription reference))]
		ifFalse: [
			self object:( aDescription reference 
				readXml: (self access 
					readNode: self target readTarget 
				description: aDescription))
			]	! !

MXXmlBinding subclass: #MXXmlWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXXmlWriter class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:07'!
write: anObject node: aNode description: aDescription
	^ self new write: anObject node: aNode description: aDescription! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/8/2010 17:28'!
node
	^ self target targetNode! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 11:06'!
node: aNode
	self target currentNode: aNode! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 12:45'!
visitContainer: aDescription
	(aDescription children select:[:each| each isXmlExportable ]) do: [:each|
		((self object readUsing: each) ifNotNilDo: [:obj|
			self access
				writeNode: (each xmlWriter
					write: self object
					node: self target targetNode
					description: each) node
				node: self target targetNode
				description: obj description
			])
	]! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 19:36'!
visitDateDescription: aDescription
	self write: (self object readUsing: aDescription) asUTC asString
		! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 12:41'!
visitMultipleOptionDescription: aDescription
	(self object readUsing: aDescription) do: [:each|
		self write: each]
		! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 2/16/2010 00:52'!
visitNumberDescription: aDescription
	self visitStringDescription: aDescription
	! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 12:42'!
visitSingleOptionDescription: aDescription
	self 
		write: (object readUsing: aDescription) 
		using: aDescription reference
		! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:56'!
visitStringDescription: aDescription
	self access 
		write: (self object readUsing: aDescription) asString
		node: self target targetNode
		description: aDescription! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 19:44'!
visitToManyRelationDescription: aDescription
	(self object readUsing: aDescription) do: [:each|
		self write: each using: each description]
		
	! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 12:42'!
visitToOneRelationDescription: aDescription
	self access 
		write: (object readUsing: aDescription)
		node: self target targetNode
		description: aDescription
		! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 19:37'!
write: anObject
	self write: anObject using: anObject description! !

!MXXmlWriter methodsFor: 'visiting-description' stamp: 'NorbertHartl 3/9/2010 20:04'!
write: anObject node: aNode description: aDescription
	self target currentNode: aNode.
	self target description: aDescription.
	self 
		object: anObject;
		visit: aDescription.! !

!MXXmlWriter methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 12:46'!
write: anObject using: aDescription
	self access
		write: anObject
		node: self target targetNode
		description: aDescription
		! !

!MAContainer class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:25'!
defaultXmlAccess
	^ MXElementAccess! !

!MAContainer class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:24'!
defaultXmlNode
	^ MXSeparateNode! !

!MAToOneRelationDescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 02/22/2010 00:28'!
defaultXmlReader
	^ MXXmlReader! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:25'!
defaultXmlAccess
	^ MXAttributeAccess ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:23'!
defaultXmlNode
	^ MXSameNode! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 02/22/2010 00:25'!
defaultXmlReader
	^ MXXmlReader ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 15:08'!
defaultXmlWriter
	^MXXmlWriter ! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 18:42'!
descriptionXmlElementName
	^(MAStringDescription selector: #xmlElementName label: 'XML Element Name' priority: 1000)! !

!MADescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 02/22/2010 00:26'!
descriptionXmlReader
	^ (MASingleOptionDescription selector: #xmlReader label: 'XML Reader' priority: 1300 default: self defaultXmlReader)
		reference: MAClassDescription new;
		options: (Array
			with: MXXmlReader);
		yourself ! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/19/2010 17:53'!
beXmlExportable
	self propertyAt: #xmlExportable put: true! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/15/2010 22:26'!
fromXml: aString
	"Answer an object being parsed from <code>aString</code>."

	^ self fromXml: aString reader: self xmlReader! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/17/2010 14:40'!
fromXml: aString reader: aParser
	"Answer an object being parsed from <code>aNode</code> using <code>aParser</code>."

	^ aParser
		read: (XMLDOMParser parseDocumentFrom: aString readStream) elements first
		description: self! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/19/2010 17:53'!
isXmlExportable
	^ self propertyAt: #xmlExportable ifAbsent: [ false ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 13:15'!
readXml: aNode
	"Answer an object being parsed from <code>aString</code>."

	^ self xmlReader read: aNode description: self! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 08:34'!
xmlAccess
	^ self propertyAt: #xmlAccess ifAbsent: [ self class defaultXmlAccess ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 08:46'!
xmlAccess: aClass
	self propertyAt: #xmlAccess put: aClass! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:17'!
xmlElementName
	^self
		propertyAt: #xmlElementName
		ifAbsent: [ self accessor selector asString ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/5/2006 20:16'!
xmlElementName: aString
	self propertyAt: #xmlElementName put: aString! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 08:33'!
xmlNode
	^ self propertyAt: #xmlNode ifAbsent: [ self class defaultXmlNode ]! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 08:33'!
xmlNode: aClass
	self propertyAt: #xmlNode put: aClass! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 17:50'!
xmlReader
	^ (self propertyAt: #xmlReader ifAbsent: [ self class defaultXmlReader ] )new 
		target: (self propertyAt: #xmlNode ifAbsent: [ self class defaultXmlNode ]) new ;
		access: (self propertyAt: #xmlAccess ifAbsent: [ self class defaultXmlAccess ]) new! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 10:35'!
xmlReader: aReader! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:17'!
xmlWriter
	
	^ (self propertyAt: #xmlWriter ifAbsent: [ self class defaultXmlWriter ] ) new 
		target: (self propertyAt: #xmlNode ifAbsent: [ self class defaultXmlNode ]) new ;
		access: (self propertyAt: #xmlAccess ifAbsent: [ self class defaultXmlAccess ]) new! !

!MADescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 2/21/2010 18:15'!
xmlWriter: aWriter
	self propertyAt: #xmlWriter put: aWriter! !

!MARelationDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 3/17/2007 15:41'!
xmlElementName
	^self
		propertyAt: #xmlElementName
		ifAbsent: [ self reference xmlElementName ]! !

TestCase subclass: #MXXmlRelationEmbedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXXmlRelationEmbedTest methodsFor: 'fixtures' stamp: 'NorbertHartl 3/15/2010 18:59'!
embedObject
	^ MXRelationEmbedSource new
		title: 'A title';
		target: (
			MXRelationEmbedTarget new
				name: 'A name')! !

!MXXmlRelationEmbedTest methodsFor: 'testing' stamp: 'NorbertHartl 3/16/2010 14:02'!
testEmbedWrite
	| object xmlString |
	object := self embedObject.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	self assert: xmlString = '<relationEmbedSource embedTargetName="A name" title="A title"/> '.! !

TestCase subclass: #MXXmlRelationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXXmlRelationTest methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 09:04'!
findTitle: aString in: aCollection
	^ (aCollection 
		detect: [:each| each title = aString]
		ifNone: [ nil ]) notNil! !

!MXXmlRelationTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/17/2010 13:37'!
onoToMany
	^ MXOneToManySource new
		label: 'A label';
		targets: (
			OrderedCollection new
				add:(MXRelationTarget new
					title: 'title1');
				add:(MXRelationTarget new
					title: 'title2');
				add:(MXRelationTarget new
					title: 'title3');
				yourself
			);
		inlineTargets: (
			OrderedCollection new
				add:(MXRelationInlineTarget new
					title: 'inline title1');
				add:(MXRelationInlineTarget new
					title: 'inline title2');
				add:(MXRelationInlineTarget new
					title: 'inline title3');
				yourself
			)! !

!MXXmlRelationTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/17/2010 13:37'!
onoToOne
	^ MXOneToOneSource new
		label: 'A label';
		target: (
			MXRelationTarget new
				title: 'A title');
		inlineTarget: (
			MXRelationInlineTarget new
				title: 'An inline title')! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'NorbertHartl 3/10/2010 16:15'!
testOneToManyRoundtrip
	| object xmlString created |
	object := self onoToMany.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	created := MXOneToManySource fromXml: xmlString.
	self assert: object label = created label.
	self assert: created targets notNil.
	self assert: created targets notEmpty.
	self assert: object targets size = created targets size.
	self assert: (self findTitle: 'title1' in: created targets).
	self assert: (self findTitle: 'title2' in: created targets).
	self assert: (self findTitle: 'title3' in: created targets).
	self assert: created inlineTargets notEmpty.
	self assert: (self findTitle: 'inline title1' in: created inlineTargets).
	self assert: (self findTitle: 'inline title2' in: created inlineTargets).
	self assert: (self findTitle: 'inline title3' in: created inlineTargets).
! !

!MXXmlRelationTest methodsFor: 'testing' stamp: 'NorbertHartl 2/21/2010 17:51'!
testOneToOneRoundtrip
	| object xmlString created |
	object := self onoToOne.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	created := MXOneToOneSource fromXml: xmlString.
	self assert: object label = created label.
	self assert: created target notNil.
	self assert: object target title = created target title.
	self assert: object inlineTarget title = created inlineTarget title.
! !

TestCase subclass: #MXXmlSimpleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXXmlSimpleTest methodsFor: 'fixtures' stamp: 'NorbertHartl 2/21/2010 08:04'!
simpleObject
	^ MXSimpleObject new
		title: 'A title';
		abstract: 'A longer text as abstract';
		token: 'article';
		index: 100000 atRandom;
		date: Date today! !

!MXXmlSimpleTest methodsFor: 'testing' stamp: 'NorbertHartl 03/11/2010 16:10'!
testSimpleRoundtrip
	| object xmlString created |
	object := self simpleObject.
	xmlString := String streamContents: [:stream|
		object printXMLOn: stream].
	created := MXSimpleObject fromXml: xmlString.
	self assert: object title = created title.
	self assert: object index = created index.
	self assert: object abstract = created abstract.
	self assert: object token = created token! !

!MAElementDescription class methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
descriptionXmlAttributeName
	^(MAStringDescription selector: #xmlAttributeName label: 'XML Attribute Name' priority: 1100)! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
xmlAttributeName
	^self
		propertyAt: #xmlAttributeName
		ifAbsent: [ self accessor selector asString ]! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'pmm 12/6/2006 00:18'!
xmlAttributeName: aString
	self propertyAt: #xmlAttributeName put: aString! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 3/16/2010 13:55'!
xmlAttributeSelector
	^self
		propertyAt: #xmlAttributeSelector
		ifAbsent: [ #yourself ]! !

!MAElementDescription methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 3/16/2010 13:59'!
xmlAttributeSelector: aSymbol
	self propertyAt: #xmlAttributeSelector put: aSymbol! !

Object subclass: #MXNodeAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXNodeAccess subclass: #MXAttributeAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXAttributeAccess methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 03/11/2010 16:10'!
readNode: aNode description: aDescription
	^ aNode attributes 
			at: aDescription xmlAttributeName asSymbol
			ifAbsent: [nil]
			! !

!MXAttributeAccess methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 13:56'!
write: anObject node: aNode description: aDescription
	"(anObject isKindOf: MXRelationEmbedTarget) ifTrue: [
		self halt]."
	aNode attributes 
			at: aDescription xmlAttributeName 
			put: (anObject perform: aDescription xmlAttributeSelector)! !

MXNodeAccess subclass: #MXContentAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXContentAccess methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 03/11/2010 15:38'!
readNode: aNode description: aDescription
	^ aNode contentString! !

!MXContentAccess methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 12:49'!
write: anObject node: aNode description: aDescription
	aNode
		addContent: (XMLStringNode string: anObject asString)! !

MXNodeAccess subclass: #MXElementAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXElementAccess methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 03/11/2010 15:39'!
readNode: aNode description: aDescription
	^ aNode elementAt: aDescription xmlElementName asSymbol! !

!MXElementAccess methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 13:42'!
write: anObject node: aNode description: aDescription
	| childNode |
	childNode := anObject toXml: aNode.
	self writeNode: childNode node: aNode description: aDescription! !

!MXElementAccess methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 12:46'!
writeNode: aChildNode node: aNode description: aDescription
	aNode ~~ aChildNode ifTrue: [
		(aChildNode elements notEmpty 
			or: [aChildNode contents notEmpty] 
			or: [aChildNode attributes notEmpty]) ifTrue: [
				aNode addElement: aChildNode]]! !

!MXNodeAccess methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 09:17'!
write: aString node: aNode
	self subclassResponsibility! !

Object subclass: #MXObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXObject class methodsFor: 'accessing-description' stamp: 'NorbertHartl 02/18/2010 14:41'!
descriptionContainer
	^super descriptionContainer
		xmlElementName: self xmlElementName;
		yourself
! !

!MXObject class methodsFor: 'accessing' stamp: 'NorbertHartl 02/18/2010 09:49'!
forElementNamed: aString
	self withAllConcreteClassesDo: [ :each |
		(each description xmlElementName = aString)
			ifTrue: [ ^each new ] ].
	self error: 'unknown element name: ', aString! !

!MXObject class methodsFor: 'instance creation' stamp: 'NorbertHartl 2/15/2010 11:27'!
fromXml: aString
	^self description fromXml: aString! !

!MXObject class methodsFor: 'testing' stamp: 'NorbertHartl 2/15/2010 11:27'!
isAbstract
	^ true! !

!MXObject class methodsFor: 'reflection' stamp: 'NorbertHartl 2/15/2010 11:27'!
withAllConcreteClasses
	^Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!MXObject class methodsFor: 'reflection' stamp: 'NorbertHartl 2/15/2010 11:27'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!MXObject class methodsFor: 'accessing' stamp: 'NorbertHartl 02/18/2010 14:42'!
xmlElementName
	self subclassResponsibility! !

!MXObject methodsFor: 'printing' stamp: 'NorbertHartl 3/15/2010 19:25'!
printXMLOn: aStream
	(self toXml: XMLDocument new)
		printXMLOn: (XMLWriter on: aStream)! !

!MXObject methodsFor: 'converting' stamp: 'NorbertHartl 3/15/2010 19:28'!
toXml: aNode
	^ self toXml: aNode using: self description! !

!MXObject methodsFor: 'converting' stamp: 'NorbertHartl 3/15/2010 19:28'!
toXml: aNode using: aDescription
	^ aDescription xmlWriter 
		write: self 
		node: aNode 
		description: aDescription;
		node! !

MXObject subclass: #MXOneToManySource
	instanceVariableNames: 'label targets inlineTargets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXOneToManySource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 13:56'!
descriptionInlineTargets
	^(MAToManyRelationDescription new 
		accessor: #inlineTargets; 
		label: '1:m inline targets'; 
		priority: 600)
		reference: MXRelationInlineTarget description;
		xmlNode: MXSameNode;
		xmlAccess: MXElementAccess;
		xmlElementName: 'itargets';
		beXmlExportable;
		yourself! !

!MXOneToManySource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:10'!
descriptionLabel
	^ MAStringDescription new
		accessor: #label;
		priority: 100;
		label: 'Label';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXOneToManySource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 14:56'!
descriptionTargets
	^(MAToManyRelationDescription new 
		accessor: #targets; 
		label: '1:m targets'; 
		priority: 600)
		reference: MXRelationTarget description;
		xmlNode: MXChildNode;
		xmlAccess: MXElementAccess;
		xmlElementName: 'ftargets';
		beXmlExportable;
		yourself! !

!MXOneToManySource class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:54'!
isAbstract
	^ false! !

!MXOneToManySource class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:42'!
xmlElementName
	^ 'toManySource'! !

!MXOneToManySource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:59'!
inlineTargets
	^ inlineTargets! !

!MXOneToManySource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:59'!
inlineTargets: aCollection
	inlineTargets := aCollection! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
label
	^ label! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
label: aString
	label := aString! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
targets
	^ targets! !

!MXOneToManySource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:54'!
targets: aCollection
	targets := aCollection! !

MXObject subclass: #MXOneToOneSource
	instanceVariableNames: 'label target inlineTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXOneToOneSource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:49'!
descriptionInlineTarget
	^(MAToOneRelationDescription new 
		accessor: #inlineTarget; 
		label: '1:1 inline target'; 
		priority: 600)
		xmlElementName: 'inlineToOne';
		xmlNode: MXSameNode;
		xmlAccess: MXElementAccess;
		reference: MXRelationInlineTarget description;
		beXmlExportable;
		yourself! !

!MXOneToOneSource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:12'!
descriptionLabel
	^ MAStringDescription new
		accessor: #label;
		priority: 100;
		label: 'Label';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXOneToOneSource class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:49'!
descriptionTarget
	^(MAToOneRelationDescription new 
		accessor: #target; 
		label: '1:1 target'; 
		priority: 600)
		xmlElementName: 'toOne';
		xmlNode: MXChildNode;
		xmlAccess: MXElementAccess;
		reference: MXRelationTarget description;
		beXmlExportable;
		yourself! !

!MXOneToOneSource class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:51'!
isAbstract
	^ false! !

!MXOneToOneSource class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:43'!
xmlElementName
	^ 'toOneSource'! !

!MXOneToOneSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:35'!
inlineTarget
	^ inlineTarget! !

!MXOneToOneSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/17/2010 08:36'!
inlineTarget: anObject
	inlineTarget := anObject! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:43'!
label
	^ label! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
label: aString
	label := aString! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:45'!
target
	^ target! !

!MXOneToOneSource methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:44'!
target: anObject
	target := anObject! !

MXObject subclass: #MXRelationEmbedSource
	instanceVariableNames: 'title target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationEmbedSource class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/16/2010 14:01'!
descriptionTarget
	^(MAToOneRelationDescription new 
		accessor: #target; 
		label: '1:1 embed target'; 
		priority: 600)
		xmlElementName: 'embedTarget';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		xmlAttributeName: 'embedTargetName';
		xmlAttributeSelector: #name;
		reference: MXRelationEmbedTarget description;
		beXmlExportable;
		yourself! !

!MXRelationEmbedSource class methodsFor: 'description' stamp: 'NorbertHartl 3/15/2010 18:53'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beXmlExportable;
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		yourself! !

!MXRelationEmbedSource class methodsFor: 'testing' stamp: 'NorbertHartl 3/15/2010 18:53'!
isAbstract
	^ false! !

!MXRelationEmbedSource class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 18:56'!
xmlElementName
	^ 'relationEmbedSource'! !

!MXRelationEmbedSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 19:01'!
target
	^ target! !

!MXRelationEmbedSource methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 19:01'!
target: anObject
	target := anObject! !

!MXRelationEmbedSource methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:53'!
title
	^ title! !

!MXRelationEmbedSource methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:53'!
title: aString
	title := aString! !

MXObject subclass: #MXRelationEmbedTarget
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationEmbedTarget class methodsFor: 'description' stamp: 'NorbertHartl 3/15/2010 18:55'!
descriptionName
	^ MAStringDescription new
		accessor: #name;
		priority: 100;
		label: 'Name';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXRelationEmbedTarget class methodsFor: 'testing' stamp: 'NorbertHartl 3/15/2010 18:54'!
isAbstract
	^ false! !

!MXRelationEmbedTarget class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/15/2010 18:56'!
xmlElementName
	^ 'relationEmbedTarget'! !

!MXRelationEmbedTarget methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:54'!
name
	^ name! !

!MXRelationEmbedTarget methodsFor: 'accessing' stamp: 'NorbertHartl 3/15/2010 18:54'!
name: aString
	name := aString! !

MXObject subclass: #MXRelationInlineTarget
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationInlineTarget class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:13'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXRelationInlineTarget class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 13:36'!
isAbstract
	^ false! !

!MXRelationInlineTarget class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:43'!
xmlElementName
	^ 'inlineTarget'! !

!MXRelationInlineTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 13:36'!
title
	^ title! !

!MXRelationInlineTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 13:36'!
title: aString
	title := aString! !

MXObject subclass: #MXRelationTarget
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXRelationTarget class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:14'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;
		yourself! !

!MXRelationTarget class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 06:51'!
isAbstract
	^ false! !

!MXRelationTarget class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:54'!
xmlElementName
	^ 'elementtarget'! !

!MXRelationTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
title
	^ title! !

!MXRelationTarget methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 06:42'!
title: aString
	title := aString! !

MXObject subclass: #MXSimpleObject
	instanceVariableNames: 'title abstract token index date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding-Test'!

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 11:46'!
descriptionAbstract
	^ MAStringDescription new
		accessor: #abstract;
		priority: 150;
		label: 'Abstract';
		xmlNode: MXChildNode;
		xmlAccess: MXContentAccess;
		beXmlExportable;
		yourself! !

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 10:55'!
descriptionIndex
	^ MANumberDescription new
		accessor: #index;
		priority: 200;
		label: 'Index';
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		beXmlExportable;	
		yourself! !

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 09:30'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beXmlExportable;
		xmlNode: MXSameNode;
		xmlAccess: MXAttributeAccess;
		yourself! !

!MXSimpleObject class methodsFor: 'description' stamp: 'NorbertHartl 2/21/2010 08:36'!
descriptionToken
	^ MAStringDescription new
		accessor: #token;
		priority: 180;
		label: 'Title';
		xmlNode: MXChildNode;
		xmlAccess: MXAttributeAccess;
		xmlAttributeName: 'type';
		beXmlExportable;
		yourself! !

!MXSimpleObject class methodsFor: 'testing' stamp: 'NorbertHartl 2/17/2010 05:20'!
isAbstract
	^ false! !

!MXSimpleObject class methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 02/18/2010 14:44'!
xmlElementName
	^ 'simpleobject'! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:26'!
abstract
	^ abstract! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:26'!
abstract: aString
	abstract := aString! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
date
	^ date! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
date: aDate
	date := aDate! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
index
	^ index! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
index: aNumber
	index := aNumber! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:12'!
title
	^ title! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:11'!
title: aString
	title := aString! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:36'!
token
	^ token! !

!MXSimpleObject methodsFor: 'accessing' stamp: 'NorbertHartl 2/17/2010 05:37'!
token: aString
	token := aString! !

Object subclass: #MXTargetNode
	instanceVariableNames: 'currentNode targetNode description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

MXTargetNode subclass: #MXChildNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXChildNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 03/11/2010 15:37'!
readTarget
	^ currentNode elementAt: description xmlElementName asSymbol! !

!MXChildNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 3/8/2010 15:43'!
targetNode
	^ targetNode ifNil: [
		targetNode := XMLElement new name: description xmlElementName.
		"currentNode addElement: targetNode."
		targetNode ]! !

MXTargetNode subclass: #MXSameNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXSameNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:39'!
readTarget
	^ currentNode! !

!MXSameNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 09:28'!
targetNode
	^ currentNode! !

MXTargetNode subclass: #MXSeparateNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-XMLBinding'!

!MXSeparateNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:23'!
readTarget
	^ currentNode! !

!MXSeparateNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 03/09/2010 17:59'!
targetNode
	^ targetNode ifNil: [
		targetNode := XMLElement new name: description xmlElementName.
		targetNode ]! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 08:55'!
currentNode
	^ currentNode! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 09:05'!
currentNode: aNode
	currentNode := aNode! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 09:10'!
description: aDescription
	description := aDescription! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 10:18'!
readTarget
	self subclassResponsibility! !

!MXTargetNode methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 2/21/2010 08:56'!
targetNode
	self subclassResponsibility! !

!MAToManyRelationDescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 02/22/2010 00:27'!
defaultXmlReader
	^ MXXmlReader! !

!MAToManyRelationDescription class methodsFor: '*magritte-xmlbinding' stamp: 'NorbertHartl 02/22/2010 00:27'!
defaultXmlWriter
	^ MXXmlWriter! !
